/*
 * Program na vypocet O-C z JD pozorovani.
 * Autor: Lubos Brat
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

void main(void)
{
  /* DEFINICE PROMENNYCH */
  char hvezda[20];
  char hvezda_a[10], hvezda_b[10];
  char odpad[10];
  char input_file[200];
  char output_file[200];
  char smazat, pokracovat, pom1, pom2;
  char line[150], input_line[150];
  char star1[10], star2[10], starc1[10], starc2[10], mag[7];
  char RA[10], DE[10], JDs[15], MAX[8], MIN[8];
  int match, i;
  long signed epoch;
  float omenec, ocs[3];
  double M, M2;
  long double JD, JDmin, JDm[3], PER;
  FILE *fr, *fw;

     // VYPIS HLAVICKY A ZADANI VSTUPNICH UDAJU - OBJEKT A VSTUPNI SOUBOR S DATY
     printf("****************************************************************************\n");
     printf("*		  * program: OCPRASER (JD -> O-C)                          *\n");
     printf("*		  * verze a datum: verze 1.1, 22.4.2000                    *\n");
     printf("*		  * autor: (c) Lubos Brat, 2000  		           *\n");
     printf("****************************************************************************\n");
     printf("\n\n");

     // KONTROLA EXISTENCE SOUBORU S KATALOGEM
       if ((fr = fopen("katalog.txt", "r")) == NULL) {
	 printf("\nSoubor 'katalog.txt' nelze najit!\n");
	 printf("Overte prosim, zda je umisten v aktualnim adresari.\n\n");
	 exit(0);
       }
	fclose(fr);

     // NACTENI NAZVU OBJEKTU
   match = 0;
   do {
     printf("Zadejte nazev sledovaneho objektu: ");
     scanf("%s %s", &hvezda_a, &hvezda_b);
     fr = fopen("katalog.txt", "r");
     while (fgets(line, 150, fr) != NULL) {
       sscanf(line, "%s %s %s", &star1, &star2, &odpad);
       if ((strcmp(star1, hvezda_a) == 0) && (strcmp(star2, hvezda_b) == 0)) {
	  match = 1;
       }
     }
     fclose(fr);

     if (match == 1) {
       printf("OK: %s %s\n\n\n", hvezda_a, hvezda_b);
     }
     else {
       printf("NENALEZENO: Objekt %s %s nebyl nalezen v souboru 'katalog.txt'.\n\n", hvezda_a, hvezda_b);
      }
   } while (match != 1);



     // NACTENI NAZVU VSTUPNIHO SOUBORU
   match = 0;
   do {
     printf("Zadejte vstupni soubor s daty: ");
     scanf("%s", input_file);
     // KONTROLA EXISTENCE SOUBORU S DATY
       if ((fr = fopen(input_file, "r")) == NULL) {
	 printf("NENALEZENO: Soubor %s nebyl nalezen v aktualnim dresari!\n\n", input_file);
	 match = 0;
       } else {
	 printf("OK: %s\n\n\n", input_file);
	 match = 1;
       }
       fclose(fr);
   } while (match != 1);



     // NACTENI NAZVU VYSTUPNIHO SOUBORU
   match = 0;
   do {
     printf("Zadejte nazev vystupniho souboru: ");
     scanf("%s", output_file);

      // KONTROLA EXISTENCE VYSTUPNIHO SOUBORU
       if ((fr = fopen(output_file, "r")) == NULL) {
	 printf("OK: %s\n\n\n", output_file);
	 match = 1;
       }
       else {
	 printf("\nSoubor s nazvem %s jiz existuje!\n", output_file);
	 printf("Chcete jej prepsat? [A/N]: ");
	 scanf("%s", &smazat);
	 if (smazat == 'a' || smazat == 'A') {
	   // SOUBOR BUDE PREPSAN NOVYM OBSAHEM
	   printf("OK: %s\n\n\n", output_file);
	   match = 1;
	 }
	 else {
	   match = 0;
	 }
       }
       fclose(fr);
   } while (match != 1);

  match = 0;
  do {
  // NACTENI UDAJU O HVEZDE Z KATALOGU
  fr = fopen("katalog.txt", "r");
  while (fgets(line, 150, fr) != NULL) {
    sscanf(line, "%s%s %s", &starc1, &starc2, &odpad);
    if ((strcmp(hvezda_a,starc1) == 0) && (strcmp(hvezda_b,starc2) == 0)) {
      sscanf(line,"%s%s %s %s %lf %Lf %s %s", &star1, &star2, &RA, &DE, &M, &PER, &MAX, &MIN);
    }
  }
  fclose(fr);
   printf("Hvezda    : %s %s\n", star1, star2);
   printf("RA (2000) : %s\n", RA);
   printf("DE (2000) : %s\n", DE);
   printf("M0        : %lf\n", M);
   printf("Perioda   : %12.10Lf\n", PER);
   printf("Max (mag) : %s\n", MAX);
   printf("Min (mag) : %s\n", MIN);

   printf("\nJsou udaje ziskane z katalogu spravne? [A/N -> nacist znovu]: ");
   scanf("%s", &pokracovat);
   if (pokracovat == 'a' || pokracovat == 'A') {
     printf("OK: udaje v poradku.\n\n\n");
     match = 1;
   } else {
     match = 0;
   }
  } while (match != 1);


   fr = fopen(input_file, "r");
   fw = fopen(output_file, "w");
   fprintf(fw, "EPOCH\t  O-C\t\tJDo\t\t  JDc\n");
   printf("EPOCH\t  O-C\t\tJDo\t\t  JDc\n");
   while (fgets(input_line, 150, fr) != NULL) {
   sscanf(input_line, "%s", &JDs);
     JD = _atold(JDs);
     // redukce na pulnoc
     if (JD > 2400000.0000) {
	M2 = M + 2400000.0000;
     } else {
	M2 = M;
     }

     epoch = (long signed)((JD-M2)/PER);
     JDm[0]=M2+PER*(epoch-1);
     JDm[1]=M2+PER*(epoch);
     JDm[2]=M2+PER*(epoch+1);
     ocs[0]=(JD-JDm[0]);
     ocs[1]=(JD-JDm[1]);
     ocs[2]=(JD-JDm[2]);

     for (i=0; i<3; i++) {
       if (i == 0) {
	  omenec = ocs[i];
	  JDmin = JDm[i];
       }
       if (fabs(omenec) > fabs(ocs[i])) {
	  omenec = ocs[i];
	  JDmin = JDm[i];
       }
     }


     fprintf(fw, "%6.2ld\t%8.4f\t%s\t%13.5Lf\n", epoch, omenec, JDs, JDmin);
     printf("%6.2ld\t%8.4f\t%s\t%13.5Lf\n", epoch, omenec, JDs, JDmin);
   }

   fclose(fr);
   fclose(fw);

   printf("\nHOTOVO...\n");

}


